# coding: utf-8

"""
    PeerTube

    # Introduction  The PeerTube API is built on HTTP(S) and is RESTful. You can use your favorite HTTP/REST library for your programming language to use PeerTube. The spec API is fully compatible with [openapi-generator](https://github.com/OpenAPITools/openapi-generator/wiki/API-client-generator-HOWTO) which generates a client SDK in the language of your choice - we generate some client SDKs automatically:  - [Python](https://framagit.org/framasoft/peertube/clients/python) - [Go](https://framagit.org/framasoft/peertube/clients/go) - [Kotlin](https://framagit.org/framasoft/peertube/clients/kotlin)  See the [Quick Start guide](https://docs.joinpeertube.org/#/api-rest-getting-started) so you can play with the PeerTube API.  # Authentication  When you sign up for an account, you are given the possibility to generate sessions, and authenticate using this session token. One session token can currently be used at a time.  ## Roles  Accounts are given permissions based on their role. There are three roles on PeerTube: Administrator, Moderator, and User. See the [roles guide](https://docs.joinpeertube.org/#/admin-managing-users?id=roles) for a detail of their permissions.  # Errors  The API uses standard HTTP status codes to indicate the success or failure of the API call. The body of the response will be JSON in the following format.  ``` {   \"code\": \"unauthorized_request\", // example inner error code   \"error\": \"Token is invalid.\" // example exposed error message } ```   # noqa: E501

    The version of the OpenAPI document: 2.4.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from peertube.configuration import Configuration


class InlineResponse2007VideoId(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'playlist_element_id': 'int',
        'playlist_id': 'int',
        'start_timestamp': 'int',
        'stop_timestamp': 'int'
    }

    attribute_map = {
        'playlist_element_id': 'playlistElementId',
        'playlist_id': 'playlistId',
        'start_timestamp': 'startTimestamp',
        'stop_timestamp': 'stopTimestamp'
    }

    def __init__(self, playlist_element_id=None, playlist_id=None, start_timestamp=None, stop_timestamp=None, local_vars_configuration=None):  # noqa: E501
        """InlineResponse2007VideoId - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._playlist_element_id = None
        self._playlist_id = None
        self._start_timestamp = None
        self._stop_timestamp = None
        self.discriminator = None

        if playlist_element_id is not None:
            self.playlist_element_id = playlist_element_id
        if playlist_id is not None:
            self.playlist_id = playlist_id
        if start_timestamp is not None:
            self.start_timestamp = start_timestamp
        if stop_timestamp is not None:
            self.stop_timestamp = stop_timestamp

    @property
    def playlist_element_id(self):
        """Gets the playlist_element_id of this InlineResponse2007VideoId.  # noqa: E501


        :return: The playlist_element_id of this InlineResponse2007VideoId.  # noqa: E501
        :rtype: int
        """
        return self._playlist_element_id

    @playlist_element_id.setter
    def playlist_element_id(self, playlist_element_id):
        """Sets the playlist_element_id of this InlineResponse2007VideoId.


        :param playlist_element_id: The playlist_element_id of this InlineResponse2007VideoId.  # noqa: E501
        :type playlist_element_id: int
        """

        self._playlist_element_id = playlist_element_id

    @property
    def playlist_id(self):
        """Gets the playlist_id of this InlineResponse2007VideoId.  # noqa: E501


        :return: The playlist_id of this InlineResponse2007VideoId.  # noqa: E501
        :rtype: int
        """
        return self._playlist_id

    @playlist_id.setter
    def playlist_id(self, playlist_id):
        """Sets the playlist_id of this InlineResponse2007VideoId.


        :param playlist_id: The playlist_id of this InlineResponse2007VideoId.  # noqa: E501
        :type playlist_id: int
        """

        self._playlist_id = playlist_id

    @property
    def start_timestamp(self):
        """Gets the start_timestamp of this InlineResponse2007VideoId.  # noqa: E501


        :return: The start_timestamp of this InlineResponse2007VideoId.  # noqa: E501
        :rtype: int
        """
        return self._start_timestamp

    @start_timestamp.setter
    def start_timestamp(self, start_timestamp):
        """Sets the start_timestamp of this InlineResponse2007VideoId.


        :param start_timestamp: The start_timestamp of this InlineResponse2007VideoId.  # noqa: E501
        :type start_timestamp: int
        """

        self._start_timestamp = start_timestamp

    @property
    def stop_timestamp(self):
        """Gets the stop_timestamp of this InlineResponse2007VideoId.  # noqa: E501


        :return: The stop_timestamp of this InlineResponse2007VideoId.  # noqa: E501
        :rtype: int
        """
        return self._stop_timestamp

    @stop_timestamp.setter
    def stop_timestamp(self, stop_timestamp):
        """Sets the stop_timestamp of this InlineResponse2007VideoId.


        :param stop_timestamp: The stop_timestamp of this InlineResponse2007VideoId.  # noqa: E501
        :type stop_timestamp: int
        """

        self._stop_timestamp = stop_timestamp

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InlineResponse2007VideoId):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, InlineResponse2007VideoId):
            return True

        return self.to_dict() != other.to_dict()
