# coding: utf-8

"""
    PeerTube

    # Introduction  The PeerTube API is built on HTTP(S) and is RESTful. You can use your favorite HTTP/REST library for your programming language to use PeerTube. The spec API is fully compatible with [openapi-generator](https://github.com/OpenAPITools/openapi-generator/wiki/API-client-generator-HOWTO) which generates a client SDK in the language of your choice - we generate some client SDKs automatically:  - [Python](https://framagit.org/framasoft/peertube/clients/python) - [Go](https://framagit.org/framasoft/peertube/clients/go) - [Kotlin](https://framagit.org/framasoft/peertube/clients/kotlin)  See the [Quick Start guide](https://docs.joinpeertube.org/#/api-rest-getting-started) so you can play with the PeerTube API.  # Authentication  When you sign up for an account, you are given the possibility to generate sessions, and authenticate using this session token. One session token can currently be used at a time.  ## Roles  Accounts are given permissions based on their role. There are three roles on PeerTube: Administrator, Moderator, and User. See the [roles guide](https://docs.joinpeertube.org/#/admin-managing-users?id=roles) for a detail of their permissions.  # Errors  The API uses standard HTTP status codes to indicate the success or failure of the API call. The body of the response will be JSON in the following format.  ``` {   \"code\": \"unauthorized_request\", // example inner error code   \"error\": \"Token is invalid.\" // example exposed error message } ```   # noqa: E501

    The version of the OpenAPI document: 2.4.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from peertube.configuration import Configuration


class ServerConfigCustomTranscodingResolutions(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        '_240p': 'bool',
        '_360p': 'bool',
        '_480p': 'bool',
        '_720p': 'bool',
        '_1080p': 'bool',
        '_2160p': 'bool'
    }

    attribute_map = {
        '_240p': '240p',
        '_360p': '360p',
        '_480p': '480p',
        '_720p': '720p',
        '_1080p': '1080p',
        '_2160p': '2160p'
    }

    def __init__(self, _240p=None, _360p=None, _480p=None, _720p=None, _1080p=None, _2160p=None, local_vars_configuration=None):  # noqa: E501
        """ServerConfigCustomTranscodingResolutions - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self.__240p = None
        self.__360p = None
        self.__480p = None
        self.__720p = None
        self.__1080p = None
        self.__2160p = None
        self.discriminator = None

        if _240p is not None:
            self._240p = _240p
        if _360p is not None:
            self._360p = _360p
        if _480p is not None:
            self._480p = _480p
        if _720p is not None:
            self._720p = _720p
        if _1080p is not None:
            self._1080p = _1080p
        if _2160p is not None:
            self._2160p = _2160p

    @property
    def _240p(self):
        """Gets the _240p of this ServerConfigCustomTranscodingResolutions.  # noqa: E501


        :return: The _240p of this ServerConfigCustomTranscodingResolutions.  # noqa: E501
        :rtype: bool
        """
        return self.__240p

    @_240p.setter
    def _240p(self, _240p):
        """Sets the _240p of this ServerConfigCustomTranscodingResolutions.


        :param _240p: The _240p of this ServerConfigCustomTranscodingResolutions.  # noqa: E501
        :type _240p: bool
        """

        self.__240p = _240p

    @property
    def _360p(self):
        """Gets the _360p of this ServerConfigCustomTranscodingResolutions.  # noqa: E501


        :return: The _360p of this ServerConfigCustomTranscodingResolutions.  # noqa: E501
        :rtype: bool
        """
        return self.__360p

    @_360p.setter
    def _360p(self, _360p):
        """Sets the _360p of this ServerConfigCustomTranscodingResolutions.


        :param _360p: The _360p of this ServerConfigCustomTranscodingResolutions.  # noqa: E501
        :type _360p: bool
        """

        self.__360p = _360p

    @property
    def _480p(self):
        """Gets the _480p of this ServerConfigCustomTranscodingResolutions.  # noqa: E501


        :return: The _480p of this ServerConfigCustomTranscodingResolutions.  # noqa: E501
        :rtype: bool
        """
        return self.__480p

    @_480p.setter
    def _480p(self, _480p):
        """Sets the _480p of this ServerConfigCustomTranscodingResolutions.


        :param _480p: The _480p of this ServerConfigCustomTranscodingResolutions.  # noqa: E501
        :type _480p: bool
        """

        self.__480p = _480p

    @property
    def _720p(self):
        """Gets the _720p of this ServerConfigCustomTranscodingResolutions.  # noqa: E501


        :return: The _720p of this ServerConfigCustomTranscodingResolutions.  # noqa: E501
        :rtype: bool
        """
        return self.__720p

    @_720p.setter
    def _720p(self, _720p):
        """Sets the _720p of this ServerConfigCustomTranscodingResolutions.


        :param _720p: The _720p of this ServerConfigCustomTranscodingResolutions.  # noqa: E501
        :type _720p: bool
        """

        self.__720p = _720p

    @property
    def _1080p(self):
        """Gets the _1080p of this ServerConfigCustomTranscodingResolutions.  # noqa: E501


        :return: The _1080p of this ServerConfigCustomTranscodingResolutions.  # noqa: E501
        :rtype: bool
        """
        return self.__1080p

    @_1080p.setter
    def _1080p(self, _1080p):
        """Sets the _1080p of this ServerConfigCustomTranscodingResolutions.


        :param _1080p: The _1080p of this ServerConfigCustomTranscodingResolutions.  # noqa: E501
        :type _1080p: bool
        """

        self.__1080p = _1080p

    @property
    def _2160p(self):
        """Gets the _2160p of this ServerConfigCustomTranscodingResolutions.  # noqa: E501


        :return: The _2160p of this ServerConfigCustomTranscodingResolutions.  # noqa: E501
        :rtype: bool
        """
        return self.__2160p

    @_2160p.setter
    def _2160p(self, _2160p):
        """Sets the _2160p of this ServerConfigCustomTranscodingResolutions.


        :param _2160p: The _2160p of this ServerConfigCustomTranscodingResolutions.  # noqa: E501
        :type _2160p: bool
        """

        self.__2160p = _2160p

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ServerConfigCustomTranscodingResolutions):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ServerConfigCustomTranscodingResolutions):
            return True

        return self.to_dict() != other.to_dict()
